!= Module DynFunc
!
! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu 
! Version::   $Id: dynamic_vely.f90,v 1.1 2011-04-26 04:08:10 sugiyama Exp $ 
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǥϳز׻뤿ɬפȤʤؿ«ͤ⥸塼
!Ūˤϰʲι׻뤿δؿǼ.  
!  * ή
!  * Ϲ
!  * Ϲ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ʡؿζΥˤ, 2 ٤ΥۤѤƤ뤿, Ϲη׻ץˤ differentiate_center4 ⥸塼ꤹ뤳ȤϤǤʤΤ.
!
!== Future Plans
!

module Dynamic_vely
  !
  !۳Ѥϳزγƹη׻⥸塼. 
  !Ūˤϰʲι׻뤿δؿǼ.  
  !  * ή
  !  * Ϲ
  !  * Ϲ
  !

  !⥸塼ɤ߹
  use dc_types, only: DP

  use gridset, only:  imin,           &! x β
    &                 imax,           &! x ξ
    &                 jmin,           &! y β
    &                 jmax,           &! y ξ
    &                 kmin,           &! z β
    &                 kmax             ! z ξ
  use basicset, only: xyz_PotTempBasicZ   !ܾβ
  use constants,only: CpDry,             &!ʬǮ
    &                 Grav,              &!ϲ®
    &                 Nu,                &!
    &                 NuH2,              &!
    &                 NuV2
  use axesset, only: &
    &                xyz_avr_pyz, xyr_avr_pyr, xqz_avr_pqz, &
    &                pyz_avr_xyz, pyr_avr_xyr, pqz_avr_xqz, &
    &                xyz_avr_xqz, pyz_avr_pqz, xyr_avr_xqr, &
    &                xqz_avr_xyz, pqz_avr_pyz, xqr_avr_xyr, &
    &                xyz_avr_xyr, pyz_avr_pyr, xqz_avr_xqr, &
    &                xyr_avr_xyz, pyr_avr_pyz, xqr_avr_xqz 

  !ۤηػ
  implicit none

  !°λ
  private

  !ή׻Τδؿ public ˤ
  public Tendency_Dynamic_VelY_Long
  public Tendency_Dynamic_VelY_Short

contains

  subroutine Tendency_Dynamic_VelY_Long(                          &
    &            xqz_VelYBl, pyz_VelXNl, xqz_VelYNl, xyr_VelZNl, &
    &            xqz_Dyn)
    
    implicit none

    real(DP), intent(in)  :: xqz_VelYBl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: pyz_VelXNl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xqz_VelYNl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyr_VelZNl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(out) :: xqz_Dyn(imin:imax, jmin:jmax, kmin:kmax)

    real(DP) :: xqz_Adv(imin:imax, jmin:jmax, kmin:kmax)
    real(DP) :: xqz_Diff(imin:imax, jmin:jmax, kmin:kmax)

    if (jmin == jmax) return

    xqz_Adv  = xqz_AdvVelY(pyz_VelXNl, xqz_VelYNl, xyr_VelZNl)
    xqz_Diff = xqz_NumDiffVelY(xqz_VelYBl)
!    xqz_Turb = xqz_TurbVelY(xyz_KmBl, pyz_VelXBl, xqz_VelYBl, xyr_VelZBl) 
    
    xqz_Dyn = xqz_Adv + xqz_Diff 
    
  end subroutine Tendency_Dynamic_VelY_Long
  
  
  subroutine Tendency_Dynamic_VelY_Short(                          &
    &            pyz_VelXNs, xqz_VelYNs, xyr_VelZNs, xyz_ExnerNs, &
    &            xqz_Dyn)
    
    implicit none

    real(DP), intent(in)  :: pyz_VelXNs(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xqz_VelYNs(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyr_VelZNs(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyz_ExnerNs(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(out) :: xqz_Dyn(imin:imax, jmin:jmax, kmin:kmax)

!    real(DP) :: pyz_PGrd(imin:imax, jmin:jmax, kmin:kmax)

    if (jmin == jmax) return
    
    xqz_Dyn = - xqz_GradPi(xyz_ExnerNs, pyz_VelXNs, xqz_VelYNs, xyr_VelZNs)
    
  end subroutine Tendency_Dynamic_VelY_Short
  
!!!------------------------------------------------------------------------!!!
  function xqz_AdvVelY(pyz_VelX, xqz_VelY, xyr_VelZ)
    !
    ! x ȾʻҤ줿ˤή׻
    !
    
    !⥸塼ɤ߹
    use xyz_deriv_c4_module, only: pqz_dx_xqz, xyz_dy_xqz, xqr_dz_xqz
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in) :: pyz_VelX &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ʿ®
    real(DP), intent(in) :: xqz_VelY &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ʿ®
    real(DP), intent(in) :: xyr_VelZ &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ľ®
    real(DP)             :: xqz_AdvVelY &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ľΰή
  
!    xr_AdvVelZ = 0.0d0  !
    xqz_AdvVelY =                                                 &
      & - xqz_avr_pqz( pqz_avr_pyz( pyz_VelX ) * pqz_dx_xqz( xqz_VelY ) ) &
      & - xqz_VelY * xqz_avr_xyz( xyz_dy_xqz( xqz_VelY ) ) &
      & - xqz_avr_xqr( xqr_avr_xyr( xyr_VelZ ) * xqr_dz_xqz( xqz_VelY ) )
    
  end function xqz_AdvVelY

 
!!!------------------------------------------------------------------------!!!
  function xqz_GradPi(xyz_Exner, pyz_VelX, xqz_VelY, xyr_VelZ)
    !
    ! y ȾʻҤ줿ǤΰϷϹη׻. 
    ! ȸޤ᤿꼰Ƥ뤳Ȥ.
    !
    
    !⥸塼ɤ߹
    use xyz_deriv_module, only: xyz_dx_pyz, xyz_dy_xqz, xyz_dz_xyr, xqz_dy_xyz
        
    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in)  :: xyz_Exner &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʡؿξ
    real(DP), intent(in)  :: pyz_VelX &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʿ®
    real(DP), intent(in)  :: xqz_VelY &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʿ®
    real(DP), intent(in)  :: xyr_VelZ &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                               !ľ®
    real(DP)              :: xqz_GradPi &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                               !Ϸ
    real(DP)              :: xyz_DivVel &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                               !®٤μ«

    !®٤μ«
    xyz_DivVel = xyz_dx_pyz( pyz_VelX ) + xyz_dy_xqz( xqz_VelY ) &
      &          + xyz_dz_xyr( xyr_VelZ )
    
    !Ϸ
!    xqz_GradPi = 0.0d0
    xqz_GradPi =  &
      & xqz_avr_xyz( CpDry * xyz_PotTempBasicZ )    &
      &   * ( xqz_dy_xyz( xyz_Exner )               &
      &       - xqz_dy_xyz( Nu * xyz_DivVel ) )  
    
  end function xqz_GradPi


!!!-------------------------------------------------------------------!!!
  function xqz_NumDiffVelY(xqz_VarY)
    !
    ! z ȾʻҤ줿ǤοͳȻɾ
    !

    !⥸塼ɤ߹
    use xyz_deriv_module, only: xqz_dx_pqz, pqz_dx_xqz, xqz_dy_xyz, xyz_dy_xqz, xqz_dz_xqr, xqr_dz_xqz
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in) :: xqz_VarY &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                                    !ʪ
    real(DP)             :: xqz_NumDiffVelY &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                                    !ͳȻ
    
    xqz_NumDiffVelY = &
      &   NuH2 * ( xqz_dx_pqz( pqz_dx_xqz( xqz_VarY ) ) ) &
      & + NuH2 * ( xqz_dy_xyz( xyz_dy_xqz( xqz_VarY ) ) ) &
      & + NuV2 * ( xqz_dz_xqr( xqr_dz_xqz( xqz_VarY ) ) )
    
  end function xqz_NumDiffVelY

  
end module Dynamic_vely

