!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004, 2005. All rights reserved.
!---------------------------------------------------------------------
!= Module DisturbEnv
!
!   * Developer: SUGIYAMA Ko-ichiro, ODAKA Masatsugu
!   * Version: $Id: initialdata_disturb.f90,v 1.1 2011-04-26 04:08:10 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
! ΥǥեͤͿ뤿δܴؿ. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
!

module initialdata_disturb
  !
  !ΥǥեͤͿ뤿Υ롼. 
  !
  
  !⥸塼ɤ߹
  use dc_types,   only: STRING, DP
  use dc_message, only: MessageNotify
  use gridset_3d, only: XMin, XMax, YMin, YMax, ZMin, ZMax, &
    &                  imin,         &!  X β
    &                  imax,         &!  X ξ
    &                  jmin,         &!  Y β
    &                  jmax,         &!  Y ξ
    &                  kmin,         &!  Z β
    &                  kmax,         &!  Z ξ
    &                  nx,           &!  Z β
    &                  ny,           &!  Z ξ
    &                  nz,           &! ׻ΰΥޡ
    &                  na,           &! ׻ΰΥޡ
    &                  x_X,             &! X ɸ(顼ʻ)
    &                  y_Y,             &! X ɸ(顼ʻ)
    &                  z_Z               ! Z ɸ(顼ʻ)
  use basicset_3d,   only:                 &
    &                  SpcWetMolFr,     &!Žʬν
    &                  MolWtWet,        &!Žʬʬ
    &                  MolWtDry,        &!ʬʬ
    &                  xyz_TempBasicZ,   &! ܾβ
    &                  xyz_PressBasicZ,  &! ܾΰ
    &                  xyza_MixRtBasicZ   ! ܾκ
  use eccm_3d,  only:  eccm_molfr

  !ۤηػ
  implicit none

  !°
  private

  !ѿ
  ! Moist 
  real(DP), save   :: Humidity = 0.0d0 !м
  ! Thermal-Gauss 
  real(DP), save   :: DelMax = 0.0d0   !κ
  real(DP), save   :: XrRate = 0.0d0   !濴(ʿ)ΰФ
  real(DP), save   :: YrRate = 0.0d0   !Ⱦ(ʿ)ΰФ
  real(DP), save   :: ZrRate = 0.0d0   !Ⱦ(ľ)ΰФ
  real(DP), save   :: XcRate = 0.0d0   !濴(ʿ)ΰФ
  real(DP), save   :: YcRate = 0.0d0   !Ⱦ(ʿ)ΰФ
  real(DP), save   :: ZcRate= 0.0d0    !濴(ľ)ΰФ
  real(DP), save   :: Xc = 0.0d0       !濴(X)
  real(DP), save   :: Yc = 0.0d0       !濴(Y)
  real(DP), save   :: Zc = 0.0d0       !濴(ľ)
  real(DP), save   :: Xr = 0.0d0       !Ⱦ(X)
  real(DP), save   :: Yr = 0.0d0       !Ⱦ(Y)
  real(DP), save   :: Zr = 0.0d0       !Ⱦ(ľ)
  ! Therma-Random 
  real(DP), save   :: Zpos = 0.0d0     ! Z ɸ [m] 
  ! DryRegion 
  real(DP), save   :: XposMin = 0.0d0    ! X ɸ [m] 
  real(DP), save   :: YposMin = 0.0d0    ! Y ɸ [m] 
  real(DP), save   :: ZposMin = 0.0d0    ! Z ɸ [m] 
  real(DP), save   :: XposMax = 0.0d0    ! X ɸ [m] 
  real(DP), save   :: YposMax = 0.0d0    ! Y ɸ [m] 
  real(DP), save   :: ZposMax = 0.0d0    ! Z ɸ [m] 
  ! FLAGS
  integer, save, public :: ID_FlagInitialdataDisturbPotTemp = 0
  integer, save, public :: ID_FlagInitialdataDisturbMixRt = 0
  integer, parameter, public :: ID_FlagInitialDataDisturbPotTemp_GaussXY = 1
  integer, parameter, public :: ID_FlagInitialDataDisturbPotTemp_GaussXZ = 2
  integer, parameter, public :: ID_FlagInitialDataDisturbPotTemp_GaussXYZ = 3
  integer, parameter, public :: ID_FlagInitialDataDisturbPotTemp_random = 4
  integer, parameter, public :: ID_FlagInitialDataDisturbMixRt_dryregion = 1
  integer, parameter, public :: ID_FlagInitialDataDisturbMixRt_moist = 2

  public initialdata_disturb_nml
  public initialdata_disturb_random
  public initialdata_disturb_gaussXZ
  public initialdata_disturb_gaussXY
  public initialdata_disturb_gaussXYZ
  public initialdata_disturb_dryregion
  public initialdata_disturb_moist

contains

  subroutine initialdata_disturb_nml(cfgfile)
    ! nml ɤ߹
    !
    use dc_iounit,     only : FileOpen    

    implicit none

    character(STRING), intent(in) :: cfgfile    
    integer                       :: unit     !ֹ
    character(STRING)  :: FlagInitialdataDisturbPotTemp = ""
    character(STRING)  :: FlagInitialdataDisturbMixRt = ""

    NAMELIST /initialdata_disturb/ &
      & FlagInitialdataDisturbPotTemp, FlagInitialdataDisturbMixRt, &
      & DelMax, XrRate, XcRate, YrRate, YcRate, ZrRate, ZcRate, Zpos, &
      & XposMin, YposMin, ZposMin, XposMax, YposMax, ZposMax, Humidity
    
    call FileOpen(unit, file=cfgfile, mode='r')
    read(unit, NML=initialdata_disturb)
    close(unit)

    if (FlagInitialdataDisturbPotTemp == "GaussXY") then 
      ID_FlagInitialdataDisturbPotTemp = ID_FlagInitialdataDisturbPotTemp_GaussXY
    elseif (FlagInitialdataDisturbPotTemp == "GaussXZ") then 
      ID_FlagInitialdataDisturbPotTemp = ID_FlagInitialdataDisturbPotTemp_GaussXZ
    elseif (FlagInitialdataDisturbPotTemp == "GaussXYZ") then 
      ID_FlagInitialdataDisturbPotTemp = ID_FlagInitialdataDisturbPotTemp_GaussXYZ
    elseif (FlagInitialdataDisturbPotTemp == "random") then 
      ID_FlagInitialdataDisturbPotTemp = ID_FlagInitialdataDisturbPotTemp_random
    end if

    if (FlagInitialdataDisturbMixRt == "dryregion") then 
      ID_FlagInitialdataDisturbMixRt = ID_FlagInitialdataDisturbMixRt_dryregion
    elseif (FlagInitialdataDisturbMixRt == "moist") then 
      ID_FlagInitialdataDisturbMixRt = ID_FlagInitialdataDisturbMixRt_moist
    end if
    
    ! ֤η
    !  XMax ˤ MPI ޤ᤿ΰ褬äƤ
    Xr = minval( x_X, 1, x_X > (XMax - XMin) * XrRate )
    Xc = minval( x_X, 1, x_X > (XMax - XMin) * XcRate )
    Yr = minval( y_Y, 1, y_Y > (YMax - YMin) * YrRate )
    Yc = minval( y_Y, 1, y_Y > (YMax - YMin) * YcRate )
    Zr = minval( z_Z, 1, z_Z > (ZMax - ZMin) * ZrRate )
    Zc = minval( z_Z, 1, z_Z > (ZMax - ZMin) * ZcRate )

  end subroutine initialdata_disturb_nml

  
  subroutine initialdata_disturb_random( xyz_Var )
    
    implicit none
    
    real(DP), intent(out) :: xyz_Var(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)              :: Random           !ե뤫
    real(DP)              :: Random1(imin:imax, jmin:jmax)
    real(DP)              :: Random2(imin:imax, jmin:jmax)
    integer :: i, j, k, kpos

    !  0.0--1.0 εȯ
    do j = jmin, jmax
      do i = imin, imax
        call random_number(random)
        Random1(i,j) = random
      end do
    end do

    ! ΤȤƤϥȤʤ褦Ĵ. ʿѤκˤ. 
    do j = jmin, jmax
      do i = imin, imax
        Random2(i,j) = Random1(i,j) - sum( Random1(1:nx,j) ) / real(nx, 8) 
      end do
    end do

    ! ꤵ줿٤źѰ
    do k = kmin, kmax
      if ( z_Z(k) >= Zpos ) then 
        kpos = k
        exit
      end if
    end do

    ! ꤵ줿٤˾֤. 
    do j = 1, ny
      do i = 1, nx
        xyz_Var(i, j, kpos) = DelMax * Random2(i,j) / sum( Random2(1:nx,j) )
      end do
    end do

  end subroutine initialdata_disturb_random
  
  
  subroutine initialdata_disturb_gaussXZ(xyz_Var)

    implicit none
    
    real(DP), intent(out) :: xyz_Var(imin:imax, jmin:jmax, kmin:kmax)
    integer         :: i, j, k, n

    do k = kmin, kmax
      do j = jmin, jmax
        do i = imin, imax
          xyz_Var(i,j,k) = &
            & DelMax * dexp( - ( (x_X(i) - Xc) / Xr )**2.0d0 * 5.0d-1   &
            &                - ( (z_Z(k) - Zc) / Zr )**2.0d0 * 5.0d-1 ) 
        end do
      end do
    end do
    
  end subroutine initialdata_disturb_gaussXZ
  

  subroutine initialdata_disturb_gaussXY(xyz_Var)
    
    implicit none
    
    real(DP), intent(out) :: xyz_Var(imin:imax, jmin:jmax, kmin:kmax)
    integer         :: i, j, k, n

    do k = kmin, kmax
      do j = jmin, jmax
        do i = imin, imax
          xyz_Var(i,j,k) = &
            & DelMax * dexp( - ( (x_X(i) - Xc) / Xr )**2.0d0 * 5.0d-1   &
            &                - ( (y_Y(k) - Yc) / Yr )**2.0d0 * 5.0d-1 )
        end do
      end do
    end do
    
  end subroutine initialdata_disturb_gaussXY


  subroutine initialdata_disturb_gaussXYZ(xyz_Var)
    
    implicit none
    
    real(DP), intent(out) :: xyz_Var(imin:imax, jmin:jmax, kmin:kmax)
    integer         :: i, j, k, n

    do k = kmin, kmax
      do j = jmin, jmax
        do i = imin, imax
          xyz_Var(i,j,k) = &
            & DelMax * dexp( - ( (x_X(i) - Xc) / Xr )**2.0d0 * 5.0d-1   &
            &                - ( (y_Y(k) - Yc) / Yr )**2.0d0 * 5.0d-1   &
            &                - ( (z_Z(k) - Zc) / Zr )**2.0d0 * 5.0d-1 ) 
        end do
      end do
    end do
    
  end subroutine initialdata_disturb_gaussXYZ


  subroutine initialdata_disturb_dryregion(xyza_MixRt)
    
    implicit none
    
    real(DP), intent(out) :: xyza_MixRt(imin:imax, jmin:jmax, kmin:kmax, 1:na)
    integer         :: i, j, k, s
    
    ! XposMin:XposMax,ZposMin:ZposMax ǰϤޤ줿ΰνμ٤򥼥ˤ뤿
    ! ܾȵοͿ
    do s = 1, na
      do k = kmin,kmax  
        do j = jmin, jmax
          do i = imin,imax
            if (z_Z(k) >= ZposMin .AND. z_Z(k) < ZposMax &
              & .AND. y_Y(j) >= YposMin .AND. y_Y(k) < YposMax &
              & .AND. x_X(i) >= XposMin .AND. x_X(i) < XposMax) then
              xyza_MixRt(i,j,k,s) = - xyza_MixRtBasicZ(i,j,k,s)
            end if
          end do
        end do
      end do
    end do
    
  end subroutine initialdata_disturb_dryregion
  
  
  subroutine initialdata_disturb_moist(xyza_MixRt)
    
    implicit none
    
    real(DP), intent(out) :: xyza_MixRt(imin:imax, jmin:jmax, kmin:kmax, 1:na)
    real(DP)        :: za_MolFr(kmin:kmax, 1:na)
    integer         :: i, j, k, s
  
    ! ٥ʤ鲿⤷ʤ
    if ( Humidity == 0.0d0 ) return

    ! ʿͤʤΤ, i=0 ׻. 
    i = 1
    j = 1
    call eccm_molfr( SpcWetMolFr(1:na), Humidity, xyz_TempBasicZ(i,j,:), &
      &              xyz_PressBasicZ(i,j,:), za_MolFr )
    
    !Υ򺮹Ѵ
    do s = 1, na
      do k = 1, nz
        do j = 1, ny
          do i = 1, nx
            xyza_MixRt(i,j,k,s) = za_MolFr(k,s) * MolWtWet(s) / MolWtDry - xyza_MixRtBasicZ(i,j,k,s)
          end do
        end do
      end do
    end do
    
  end subroutine initialdata_disturb_moist
  
end module initialdata_disturb
